//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "netdriver.h"

class NetDriverBPF : public NetDriver
{
	using inherited = NetDriver;
 public:
	// コンストラクタ
	NetDriverBPF(EthernetDevice *parent_, int loglevel_,
		const std::string& ifname_);
	// デストラクタ
	~NetDriverBPF() override;

	bool InitDriver() override;
	bool SendPacket(const std::vector<uint8>& data) override;

 protected:
	ssize_t RecvPacket() override;
	void MonitorUpdateMD(TextScreen&) override;

 private:
	void Close();

	std::string FindInterface() const;

	// デバイスファイルパス
	std::string devpath {};

	std::unique_ptr<uint8[]> bpfbuf {};
	int bpfbuflen {};
};
