//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#include <unistd.h>

// 自動変数みたいな生存期間を持つディスクリプタ
class autofd
{
 public:
	autofd() {
		fd = -1;
	}
	autofd(int fd_) {
		fd = fd_;
	}

	~autofd() {
		if (fd >= 0)
			close(fd);
	}

	autofd& operator=(int fd_) {
		fd = fd_;
		return *this;
	}
	operator int() const {
		return fd;
	}

	// 明示的にクローズする
	int Close() {
		int rv = 0;
		if (fd >= 0) {
			rv = close(fd);
			fd = -1;
		}
		return rv;
	}

 public:
	int fd;
};
