//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#define M88K_EXCEP_RESET			(0)
#define M88K_EXCEP_INTERRUPT		(1)
#define M88K_EXCEP_INST				(2)
#define M88K_EXCEP_DATA				(3)
#define M88K_EXCEP_MISALIGNED		(4)
#define M88K_EXCEP_UNIMPL_OP		(5)
#define M88K_EXCEP_PRIV				(6)
#define M88K_EXCEP_BOUNDS			(7)
#define M88K_EXCEP_INT_DIV			(8)
#define M88K_EXCEP_INT_OVF			(9)
#define M88K_EXCEP_ERROR			(10)

#define M88K_EXCEP_SFU1_PRECISE		(114)
#define M88K_EXCEP_SFU1_IMPRECISE	(115)
#define M88K_EXCEP_SFU2_PRECISE		(116)
#define M88K_EXCEP_SFU3_PRECISE		(118)
#define M88K_EXCEP_SFU4_PRECISE		(120)
#define M88K_EXCEP_SFU5_PRECISE		(122)
#define M88K_EXCEP_SFU6_PRECISE		(124)
#define M88K_EXCEP_SFU7_PRECISE		(126)

// FP 例外
// 7 .. 3 が precise、2 .. 0 が imprecise
#define M88K_FPEXCEP_FIOV		(1 << 7)
#define M88K_FPEXCEP_FUNIMP		(1 << 6)
#define M88K_FPEXCEP_FPRV		(1 << 5)
#define M88K_FPEXCEP_FROP		(1 << 4)
#define M88K_FPEXCEP_FDVZ		(1 << 3)
#define M88K_FPEXCEP_FUNF		(1 << 2)
#define M88K_FPEXCEP_FOVF		(1 << 1)
#define M88K_FPEXCEP_FINX		(1 << 0)
