//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#include "opm.h"
#include "mpu.h"

std::unique_ptr<OPMDevice> gOPM;

OPMDevice::OPMDevice()
	: inherited("OPM")
{
	devaddr = baseaddr;
	devlen  = 0x2000;
}

OPMDevice::~OPMDevice()
{
}

uint64
OPMDevice::Read(uint32 offset)
{
	putlog(0, "未実装読み込み $%06x", gMPU->GetPaddr());
	return 0;
}

uint64
OPMDevice::Write(uint32 offset, uint32 data)
{
	putlog(0, "未実装書き込み $%06x <- $%02x", gMPU->GetPaddr(), data);
	return 0;
}

uint64
OPMDevice::Peek(uint32 offset)
{
	// XXX 未実装
	return 0xff;
}
