//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"
#include <sys/time.h>

class PlutoDevice : public IODevice
{
	using inherited = IODevice;
 public:
	PlutoDevice();
	virtual ~PlutoDevice() override;

	void ResetHard() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	// ROM
	static const uint16 rom[];

	// ホストファイル起動
	uint32 ROM_Load();

	// ベンチマーク
	void write_8_benchmark(uint32 addr, uint32 data);
	void benchmark_start(uint32 data);
	void benchmark_end();
	int m_count {};
	int m_test_num {};
	const char *m_test_name {};
	int m_inst_len {};
	int m_inst_cycle {};
	int m_start_addr {};
	timeval m_start {};
	timeval m_total {};
};

extern std::unique_ptr<PlutoDevice> gPluto;
