//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "ethernet.h"
#include "rom.h"
#include "stopwatch.h"

class PROMDevice : public ROMDevice
{
	using inherited = ROMDevice;
 public:
	PROMDevice();
	virtual ~PROMDevice() override;

	bool Init() override;
	bool PowerOn() override;
	void ResetHard() override;

	uint64 Read8(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;

 private:
	bool InitLuna1();
	bool InitLuna88k();
	uint64 Write(uint32 addr);

	// ROM->RAM 切り替え用フラグ。true なら ROM モード
	bool isrom {};

	// パフォーマンス測定用
	Stopwatch sw {};
};

extern std::unique_ptr<PROMDevice> gPROM;
