//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"
#include "upd7201.h"

class SCCDevice : public uPD7201Device
{
	using inherited = uPD7201Device;
 private:
	static const int baseaddr = 0xe98000;

 public:
	SCCDevice();
	virtual ~SCCDevice() override;

	// XXX 親の同名メソッドと名前分けたほうがいいか
	uint8 ReadCtrl(struct SIO::channel *chan) override;
	void WriteCtrl(struct SIO::channel *chan, uint32 data) override;

	// 割り込みアクノリッジ
	int InterruptAcknowledge();

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 4;
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);
	uint64 Peek(uint32 offset);

 private:
	void Interrupt() override;
};

extern std::unique_ptr<SCCDevice> gSCC;
