//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "vm.h"

class VM_LUNA : public VM
{
	using inherited = VM;
 public:
	VM_LUNA();
	virtual ~VM_LUNA() override;

	bool Init() override;

	// 電源ボタンを押す。
	void PowerButton() override;

	// ブートページを切り替える。
	void SwitchBootPage(Device *parent, bool isrom) override;

 protected:
	// デバイスマップから devtable を作成
	void MakeDevtable(const uint8 *maptable);

	std::unique_ptr<IODevice> prom {};
};

class VM_LUNA1 final : public VM_LUNA
{
	using inherited = VM_LUNA;
 public:
	VM_LUNA1();
	~VM_LUNA1() override;

 private:
	static const uint8 maptable[256];
};

class VM_LUNA88K final : public VM_LUNA
{
	using inherited = VM_LUNA;
 public:
	VM_LUNA88K();
	~VM_LUNA88K() override;

 private:
	static const uint8 maptable[256];
};
