//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

// カラーユニバーサルデザイン推奨配色セット (ver.4)
// https://jfly.uni-koeln.de/colorset/
//
// 基本はこの配色のみを用いること。
// ただし色を区別する(色の違いを認識できる)必要のない箇所ならここにない
// 色も使用可とする。

// 結局 define が最強…
// コンストラクトしたところでたぶんたいしたコストじゃないと思うので
// 必要なところでつどつどどっかから RGB 引いてきて、てんでバラバラに
// 書くよりはマシというくらいにしておく。

// アクセントカラー (文字など)
#define UD_RED				wxColour(255,  75,   0)	// 赤
#define UD_YELLOW			wxColour(255, 241,   0)	// 黄色
#define UD_GREEN			wxColour(  3, 175, 122)	// 緑
#define UD_BLUE				wxColour(  0,  90, 255)	// 青
#define UD_SKYBLUE			wxColour( 77, 196, 255)	// 空色
#define UD_PINK				wxColour(255, 128, 130)	// ピンク
#define UD_ORANGE			wxColour(246, 170,   0)	// オレンジ
#define UD_PURPLE			wxColour(153,   0, 153)	// 紫
#define UD_BROWN			wxColour(128,  64,   0)	// 茶色

// ベースカラー (背景など)
#define UD_LIGHT_PINK		wxColour(255, 202, 191)	// 明るいピンク
#define UD_CREAM			wxColour(255, 255, 128)	// クリーム
#define UD_YELLOW_GREEN		wxColour(216, 242,  85)	// 明るい黄緑
#define UD_LIGHT_SKYBLUE	wxColour(191, 228, 255)	// 明るい空色
#define UD_BEIGE			wxColour(255, 202, 128)	// ベージュ
#define UD_LIGHT_GREEN		wxColour(119, 217, 168)	// 明るい緑
#define UD_LIGHT_PURPLE		wxColour(201, 172, 230)	// 明るい紫

// 無彩色
#define UD_LIGHT_GREY		wxColour(200, 200, 203)	// 明るいグレー
#define UD_GREY				wxColour(132, 145, 158)	// グレー

// メモ。
// 基本的に wxBLACK, wxWHITE 以外の wxWidgets 定義色を使うことはないが
// wxOSX(-3.0.2) の wxLIGHT_GREY は値が(色も透明度も)正しくないので避ける。

//
// 以下独自色
//

// パネルの背景色。
// パネルの背景色は本来 wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW) で
// 取得できる色だと思うが、これが環境依存となると前景色との兼ね合いも再現
// できなくなるということなのでこれには依存せず、背景色は自分で確定させる。
// UD_LIGHT_GREY は背景用ではないので背景色にするには暗い。
// wxGTK(2) の wxLIGHT_GREY は (211, 211, 211) で、これも結構暗め。
// wxGTK3 はほぼ白(250) で、これは明るすぎて好みではない。
#define BGPANEL				wxColour(224, 224, 227)
